//  The code : setar@roboforum.ru
//  This work is licensed under a Creative Commons Attribution-ShareAlike 3.0 Unported License.
//  http://creativecommons.org/licenses/by-sa/3.0/

#define TERMOCOUPLE_PIN 8 // termocouple port
#define HEATER_PIN 10 // "Heated bed" port
#define TERMISTOR_PIN 14 // T1( label"2") port in megatronics v1 


//int LED1 = 9;             // Status LED Pin
int TermistorPin = 14;           // Gnd pin for Termistor ; as analog input pin
int TermocouplePin = 8;         // Raw pin for Termocouple ; as analog input pin
int HeaterPin = 10;         // pin for enable Heater ; as digital output pin
double Termistor_raw;          // Current RAW analog data from termistor
double Termocouple_raw;          // Current RAW analog data from termistor
float Termistor_temp   = 0.0;  // Temperature output variable from termistor
float Termocouple_temp = 0.0;  // Temperature output variable from termocouple
int Samples = 16;            // num of samples in measure
float Termocouple_adj = 0; // adjust temp of termocouple

float analog2temp(int raw) {
    int celsius = 0;
    byte i;

    for (i=1; i<NUMTEMPS; i++)
    {
      if (temptable[i][0] > raw)
      {
        celsius  = temptable[i-1][1] + 
          (raw - temptable[i-1][0]) * 
          (temptable[i][1] - temptable[i-1][1]) /
          (temptable[i][0] - temptable[i-1][0]);

        break;
      }
    }

    // Overflow: Set to last value in the table
    if (i == NUMTEMPS) celsius = temptable[i-1][1];

    return celsius;

}


// Setup Serial output and LED Pin.
void setup() {
  Serial.begin(115200);

// use Arduino pins 
//  pinMode(LED1, OUTPUT);
  pinMode(TermistorPin, INPUT);
  pinMode(TermocouplePin, INPUT);

  pinMode(HeaterPin, OUTPUT); digitalWrite(HeaterPin, HIGH);

  Serial.println("\"Thermocouple\",\"Thermistor\"");
  // wait for stabilize
  delay(500);
}


void loop() {
  Termistor_raw = 0;
  Termocouple_raw = 0;
  for (int n = 0; n < Samples; n++)
  {
     Termocouple_raw += analogRead(TermocouplePin);
     Termistor_raw += analogRead(TermistorPin);
  }
     Termistor_temp = analog2temp(Termistor_raw / Samples);
     Termocouple_temp = Termocouple_raw * ((5.0 * 100.0) / 1024.0) / Samples + Termocouple_adj;
     Serial.print( "\"");
     Serial.print(Termocouple_temp);
     Serial.print( "\",\"");
     Serial.print(Termistor_raw / Samples);
     Serial.println( "\"");
     delay(3000);
}

